unit uMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, TeEngine, Series, TeeProcs, Chart,TeeEdit,
  TeeComma, TeeFunci,TeeFuncEdit;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    BarSeries1: TBarSeries;
    BarSeries2: TBarSeries;
    Panel1: TPanel;
    btTestStack: TButton;
    Chart2: TChart;
    AreaSeries1: TAreaSeries;
    AreaSeries2: TAreaSeries;
    btTestDates: TButton;
    TeeCommander1: TTeeCommander;
    BarSeries3: TBarSeries;
    AreaSeries3: TAreaSeries;
    BarSum: TLineSeries;
    TeeFunction1: TAddTeeFunction;
    AreaSum: TLineSeries;
    TeeFunction2: TAddTeeFunction;
    btTestAssign: TButton;
    btTestYears: TButton;
    btTestLineBarWidth: TButton;
    LineSeries1: TLineSeries;
    btTestStack2: TButton;
    btTestDataSource: TButton;
    btTestDatasource1: TButton;
    procedure btTestStackClick(Sender: TObject);
    procedure btTestDatesClick(Sender: TObject);
    procedure btTestAssignClick(Sender: TObject);
    procedure btTestYearsClick(Sender: TObject);
    procedure LinkTeeCommander(Sender: TObject);
    procedure btTestLineBarWidthClick(Sender: TObject);
    procedure btTestStack2Click(Sender: TObject);
    procedure btTestDataSourceClick(Sender: TObject);
    procedure btTestDatasource1Click(Sender: TObject);
  private
    { Private declarations }
    procedure evtExpandTitleLine(Sender:TObject;VAR aTitleLine:string);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses uDynChart;


procedure TForm1.btTestStack2Click(Sender: TObject);
begin
  BarSeries1.Clear;
  BarSeries2.Clear;
  BarSeries3.Clear;
  BarSeries2.Add(-5);
  BarSeries3.Add(-5);
end;

procedure TForm1.btTestStackClick(Sender: TObject);
VAR i:integer;
begin
  BarSeries1.Clear;
  BarSeries2.Clear;
  BarSeries3.Clear;
  AreaSeries1.Clear;
  AreaSeries2.Clear;
  AreaSeries3.Clear;
  for i:=0 to 10 do
  begin
    BarSeries2.Add(5-i);
    BarSeries3.Add(-3+i div 2);
    AreaSeries2.Add(5-i);
    AreaSeries3.Add(-3+i div 2);
  end;
  for i:=11 to 12 do
  begin
    BarSeries2.Add(5-i);
    AreaSeries3.Add(5-i);
  end;
  TeeFunction1.ReCalculate;
  TeeFunction2.ReCalculate;
//  BarSum.RefreshSeries;
//  AreaSum.RefreshSeries;
//  CHart1.Refresh;
//  CHart2.Refresh;


end;

procedure TForm1.btTestYearsClick(Sender: TObject);
VAR i:integer;
    d:TDateTime;
begin
  BarSeries1.XValues.DateTime:=True;
  BarSeries1.Clear;
  BarSeries2.Clear;
  BarSeries3.Clear;
  AreaSeries1.XValues.DateTime:=True;
  AreaSeries1.Clear;
  AreaSeries2.Clear;
  AreaSeries3.Clear;
  for i:=trunc(1895) to Trunc(2050) do
  begin
    d:=EncodeDate(i,1,1);
    BarSeries2.AddXY(d,Random(100)-50);
    BarSeries3.AddXY(d,Random(100)-50);
    AreaSeries2.AddXY(d,Random(100)-50);
    AreaSeries3.AddXY(d,Random(100)-50);
  end;

end;

procedure TForm1.evtExpandTitleLine(Sender: TObject; var aTitleLine: string);
begin
  aTitleLine:=aTitleLine+' - EXPANDED';
end;

procedure TForm1.LinkTeeCommander(Sender: TObject);
begin
  TeeCommander1.Panel:=Sender as TCustomChart; 
end;

procedure TForm1.btTestAssignClick(Sender: TObject);
VAR f:TfrmDynChart;
    i:integer;
begin
  f:=TfrmDynChart.Create(self);
  f.Show;
  f.Chart1.Assign(Chart1);

  // first of all copy series
  for i:=0 to Chart1.SeriesCount-1 do
    f.Chart1.AddSeries(TChartSeriesClass(Chart1.Series[i].ClassType));
  // next copy series settings
  for i:=0 to Chart1.SeriesCount-1 do
    f.Chart1.Series[i].Assign(Chart1.Series[i]);
end;

procedure TForm1.btTestLineBarWidthClick(Sender: TObject);
VAR i:integer;
begin
//  Chart1.BottomAxis.Automatic:=False;
//  Chart1.BottomAxis.Maximum:=1000;
//  Chart1.BottomAxis.Minimum:=100;
  BarSeries1.Clear;
  LineSeries1.Clear;
  for i:=1 to 10  do
   LineSeries1.AddXY(i*10,50+i*10);
  BarSeries1.AddXY(10,100);
  BarSeries1.AddXY(20,100);
  BarSeries1.AddXY(100,100);

end;

procedure TForm1.btTestDatasource1Click(Sender: TObject);
begin
  FreeAndNil(BarSeries1);
end;

procedure TForm1.btTestDataSourceClick(Sender: TObject);
VAR Str,StrTxt:TStream;
begin
  // the file wil reveal that de datasource property is stored
  // regardless of the fact if multiple datasources are linked.
  // applying the patch for the 'stored' predicate fixes this.
  Str:=TMemoryStream.Create;
  try
    Str.WriteComponent(self);
    Str.Position:=0;
    StrTxt:=TFileStream.Create('FormResource.txt',fmCreate);
    try
      ObjectBinaryToText(Str,StrTxt);
    finally
       StrTxt.Free;
    end;
  finally
    Str.Free;
  end;

end;

procedure TForm1.btTestDatesClick(Sender: TObject);
VAR i:integer;
begin
  BarSeries1.XValues.DateTime:=True;
  BarSeries1.Clear;
  BarSeries2.Clear;
  BarSeries3.Clear;
  AreaSeries1.XValues.DateTime:=True;
  AreaSeries1.Clear;
  AreaSeries2.Clear;
  AreaSeries3.Clear;
  for i:=trunc(EncodeDate(1895,1,1)) to Trunc(EncodeDate(1905,12,31)) do
  begin
    BarSeries2.AddXY(i,Random(100)-50);
    BarSeries3.AddXY(i,Random(100)-50);
    AreaSeries2.AddXY(i,Random(100)-50);
    AreaSeries3.AddXY(i,Random(100)-50);
  end;

end;

end.

